;
; ------------------------------------------------------------
;
;   Example server
;
;   by DStalk:)
;
; ------------------------------------------------------------
;

; 
#Version="0.01"
#Port=9105

;    
OpenConsole()
PrintN("Example server "+#Version)
If InitNetwork() = 0
  PrintN("Unable to init network")
  End
EndIf

;   "" - Connection  Players
; Connection     (      )
; Players   ,    
;     ID ,     ID    

; 
Structure Cons
  Packet.s
EndStructure
Global NewMap Connection.Cons()

; 
Structure Player
  ID.i
  Name.s
  X.i:Y.i
  Stats.i[6];  ,  
EndStructure
Global NewMap Players.Player()

;   
Global ch.s=Chr(31);  TCP 
Global.i TCPclientID,UpdateTime
Global.s TCPPacket

;        
Global MutexIn=CreateMutex()
Global SemaphoreIn=CreateSemaphore()
Global MutexOut=CreateMutex()
Global SemaphoreOut=CreateSemaphore()

Structure Queues
  SpecialFlag.i;  , 1 -  , 2 - 
  TCPclientID.i
  TCPData.s
EndStructure

Global NewList QueueIn.Queues()
Global NewList QueueOut.Queues()

;   
;  
Procedure ReceiveTCPData(n.i)
  
  *TCPBuffer = AllocateMemory(1024);  
  
  Repeat
  
  SEvent = NetworkServerEvent()
  
  If SEvent
    
    TCPclientIDIn = EventClient()
    
    Select SEvent
        
        ; 
      Case #PB_NetworkEvent_Connect
        LockMutex(MutexIn)
          LastElement(QueueIn())
          AddElement(QueueIn())
          QueueIn()\SpecialFlag=1
          QueueIn()\TCPclientID=TCPclientIDIn
        UnlockMutex(MutexIn)
        SignalSemaphore(SemaphoreIn)
        
        ;  
      Case #PB_NetworkEvent_Data
        ;      
        tmpLen.i=ReceiveNetworkData(TCPclientIDIn,*TCPBuffer,1000)
        tmpPacket.s=PeekS(*TCPBuffer,tmpLen)
        PrintN(Str(tmpLen)+"/"+tmpPacket)
        LockMutex(MutexIn)
          LastElement(QueueIn())
          AddElement(QueueIn())
          QueueIn()\TCPclientID=TCPclientIDIn
          QueueIn()\TCPData=tmpPacket
        UnlockMutex(MutexIn)
        SignalSemaphore(SemaphoreIn)
        
        ; / 
      Case #PB_NetworkEvent_Disconnect
        LockMutex(MutexIn)
          LastElement(QueueIn())
          AddElement(QueueIn())
          QueueIn()\SpecialFlag=2
          QueueIn()\TCPclientID=TCPclientIDIn
        UnlockMutex(MutexIn)
        SignalSemaphore(SemaphoreIn)
        
    EndSelect
  EndIf
  
  Delay(10)
  
  ForEver
  
EndProcedure

;  
Procedure SendTCPData(n.i)
  
  Repeat
    
    If TrySemaphore(SemaphoreOut)<>0
      LockMutex(MutexOut)
        FirstElement(QueueOut())
        SendNetworkString(QueueOut()\TCPclientID,QueueOut()\TCPData)
        DeleteElement(QueueOut())
      UnlockMutex(MutexOut)
    EndIf
    
    Delay(10)
  ForEver
  
EndProcedure

;---------- -------------------------------------------------------------------------------------

Declare TCPProcess(Command.s)

;     
Procedure AddSendData(clID.i,TCPData.s)
  
  LockMutex(MutexOut)
    LastElement(QueueOut())
    AddElement(QueueOut())
    QueueOut()\TCPclientID=clID
    QueueOut()\TCPData=TCPData
  UnlockMutex(MutexOut)
  SignalSemaphore(SemaphoreOut)  
  
EndProcedure

;  TCP 
Procedure.s TCPParse()
  i=FindString(TCPPacket, ch, 1)
  result$=Left(TCPPacket,i-1)
  TCPPacket=Mid(TCPPacket,i+1)
  ProcedureReturn result$
EndProcedure

;    
Procedure CheckFullPacket()
  tmpPacket.s=Connection(Str(TCPclientID))\Packet
  i=FindString(tmpPacket, Chr(10), 1)
  If i>0
    TCPPacket=Left(tmpPacket,i-1)
    Connection()\Packet=Mid(Connection()\Packet,i+1)
    TCPProcess(TCPParse())
  EndIf
EndProcedure

; (TCPClientID)     
Procedure GetPlayerPointer(pName.s)
  ForEach Players()
    If pName=Players()\Name:ProcedureReturn Val(MapKey(Players())):EndIf
  Next
  ; -1      
  ProcedureReturn -1
EndProcedure

;      /,    ,   :)
;       ,      ...
;     
Procedure RegisterPlayer()
  
  pName.s=TCPParse()
  pPass.s=TCPParse()
  pVersion.s=TCPParse()
  pEmail.s=TCPParse()
  
  ;  
  If pVersion<>#Version:AddSendData(TCPclientID,"RegisterFailed"+ch+"Please update the game client."+ch+Chr(10)):ProcedureReturn:EndIf
  
  ; 
  If CountString(pName," ")>1:AddSendData(TCPclientID,"RegisterFailed"+ch+"Too many spaces."+ch+Chr(10)):ProcedureReturn:EndIf
  If Len(pName)>16:AddSendData(TCPclientID,"RegisterFailed"+ch+"Too long name. Max 16 characters."+ch+Chr(10)):ProcedureReturn:EndIf
  If Len(pName)<3:AddSendData(TCPclientID,"RegisterFailed"+ch+"Too short name. Min 3 characters."+ch+Chr(10)):ProcedureReturn:EndIf
  
  ; 
  If Len(pPass)>16:AddSendData(TCPclientID,"RegisterFailed"+ch+"Too long password. Max 16 characters."+ch+Chr(10)):ProcedureReturn:EndIf
  If Len(pPass)<4:AddSendData(TCPclientID,"RegisterFailed"+ch+"Too short password. Min 4 characters."+ch+Chr(10)):ProcedureReturn:EndIf
  
  ;    (  ,  )
  pName=UCase(Mid(pName,1,1))+LCase(Mid(pName,2,Len(pName)-1))
  
  ;      
  DatabaseQuery(0, "SELECT ID FROM Players WHERE Name = '"+pName+"'")
    If NextDatabaseRow(0)<>0:AddSendData(TCPclientID,"RegisterFailed"+ch+"This name is unavailable."+ch+Chr(10)):FinishDatabaseQuery(0):ProcedureReturn:EndIf
  FinishDatabaseQuery(0)
  
  ;      
  DatabaseUpdate(0, "INSERT INTO Players (Name, Pass, RegDate, Email, X, Y, BanState) VALUES ('"+pName+"','"+pPass+"','"+FormatDate("%dd.%mm.%yyyy",Date())+"','"+pEmail+"',0,0,0)")
  AddSendData(TCPclientID,"RegOK"+ch+pName+ch+Chr(10))  
  
EndProcedure

;  
Procedure LoginPlayer()
  
  tStart.i=ElapsedMilliseconds()
  pName.s=TCPParse()
  pPass.s=TCPParse()
  pVersion.s=TCPParse()
  msgLogin.s="":msgStats.s=""
  
  ;    (  ,  )
  pName=UCase(Mid(pName,1,1))+LCase(Mid(pName,2,Len(pName)-1))
  
  ;       
  If pVersion<>#Version:AddSendData(TCPclientID,"LoginFailed"+ch+"Please update the game client."+ch+Chr(10)):ProcedureReturn:EndIf
  If GetPlayerPointer(pName.s)>0:AddSendData(TCPclientID,"LoginFailed"+ch+"That player is already online."+ch+Chr(10)):ProcedureReturn:EndIf
  
  ;     
  DatabaseQuery(0, "SELECT * FROM Players WHERE Name = '"+pName+"'")
    If NextDatabaseRow(0)=0:AddSendData(TCPclientID,"LoginFailed"+ch+"This player is not registered."+ch+Chr(10)):FinishDatabaseQuery(0):ProcedureReturn:EndIf
    If GetDatabaseString(0, 2)<>pPass:AddSendData(TCPclientID,"LoginFailed"+ch+"Invalid password."+ch+Chr(10)):FinishDatabaseQuery(0):ProcedureReturn:EndIf
    If GetDatabaseLong(0,13)<>0:AddSendData(TCPclientID,"LoginFailed"+ch+"This player is banned."+ch+Chr(10)):FinishDatabaseQuery(0):ProcedureReturn:EndIf
    
    ;     
    Players(Str(TCPclientID))\ID=GetDatabaseLong(0,0)
    Players()\Name=GetDatabaseString(0,1)
    Players()\X=GetDatabaseLong(0,5)
    Players()\Y=GetDatabaseLong(0,6)
    For i=0 To 5:Players()\Stats[i]=GetDatabaseLong(0,7+i):msgStats=msgStats+ch+Str(Players()\Stats[i]):Next
  FinishDatabaseQuery(0)
  
  With Players()
  
    ;    
    msgLogin=ch+Str(TCPclientID)+ch+\Name+ch+Str(\X)+ch+Str(\Y)
    
    ;      
    AddSendData(TCPclientID,"LoginOK"+msgLogin+ch+Chr(10))
    AddSendData(TCPclientID,"Stats"+msgStats+ch+Chr(10))
    
    ;  
    ForEach Players()
      ;   ,     -    :)
      AddSendData(Val(MapKey(Players())),"NewPlayer"+msgLogin+ch+Chr(10))
      ;      
      AddSendData(TCPclientID,"NewPlayer"+ch+MapKey(Players())+ch+Players()\Name+ch+Str(Players()\X)+ch+Str(Players()\Y)+ch+Chr(10))
    Next
    
  EndWith
  
  tEnd.i=ElapsedMilliseconds()-tStart
  PrintN("Login successful. Time - "+Str(tEnd)+"ms.")
  
EndProcedure

;    
Procedure SavePlayer(clID.s)

  With Players(clID)
    ;       
    dbquery1.s="X='"+Str(\X)+"', "
    dbquery1=dbquery1+"Y='"+Str(\Y)+"'"
    ;      0-5

    DatabaseUpdate(0, "UPDATE Players SET "+dbquery1+" WHERE Name = '"+\Name+"'")
  
  EndWith
  
EndProcedure

; 
Procedure MovePlayer()
  
  clID.s=Str(TCPclientID)
  pX.s=TCPParse()
  pY.s=TCPParse()
  
  ;     :)
  
  Players(clID)\X=Val(pX)
  Players()\Y=Val(pY)
  
  ;  
  ForEach Players()
    ;        (         )
    AddSendData(Val(MapKey(Players())),"Move"+ch+clID+ch+pX+ch+pY+ch+Chr(10))
  Next
  
EndProcedure

;    
Procedure TCPProcess(Command.s)
  
If FindMapElement(Players(),Str(TCPclientID))=0;      -         
  
  Select Command

  ;  
  Case "Login"
    LoginPlayer()
    
  Case "Register"
    RegisterPlayer()
    
  EndSelect
    
Else;  -   
  
  Select Command

  Case "Move"
    MovePlayer()

  EndSelect

EndIf

EndProcedure


;------------  -----------------------------------------------------------------------------------

; SQLite -       ,    Postgre    ...:)
UseSQLiteDatabase()
OpenDatabase(0, "db.sqlite", "", "")

;    -   , NPC  ..

;------------ -----------------------------------------------------------------------------------

If CreateNetworkServer(0,#Port)
  PrintN("Server started.")
  
  If CreateThread(@ReceiveTCPData(),0)=0:PrintN("Failed to start Receive thread."):Delay(5000):End:EndIf
  PrintN("Receive thread started.")
  If CreateThread(@SendTCPData(),0)=0:PrintN("Failed to start Send thread."):Delay(5000):End:EndIf
  PrintN("Send thread started.")
  
  ; 
  Repeat
    
    If TrySemaphore(SemaphoreIn)<>0
      ;    
      LockMutex(MutexIn)
        FirstElement(QueueIn())
        tmpSpecial.i=QueueIn()\SpecialFlag
        TCPclientID=QueueIn()\TCPclientID
        tmpData.s=QueueIn()\TCPData
        DeleteElement(QueueIn())
      UnlockMutex(MutexIn)
    
      Select tmpSpecial
        Case 0;   
          ;      
          Connection(Str(TCPclientID))\Packet=Connection(Str(TCPclientID))\Packet+tmpData
          ;PrintN(Connection()\Packet)
          CheckFullPacket()
        Case 1; 
          Connection(Str(TCPclientID))\Packet=""
          PrintN("New connection: "+Str(TCPclientID))
        Case 2;
          PrintN("Disconnected: "+Str(TCPclientID))
          DeleteMapElement(Connection(),Str(TCPclientID))
          ;,   
          If FindMapElement(Players(),Str(TCPclientID))>0
            SavePlayer(Str(TCPclientID))
            ;    ,    
            DeleteMapElement(Players(),Str(TCPclientID))
            ForEach Players()
              AddSendData(Val(MapKey(Players())),"DeletePlayer"+ch+Str(TCPclientID)+ch+Chr(10))
            Next
          EndIf
      EndSelect
    
    EndIf
    
    Delay(10)
    If UpdateTime+50<ElapsedMilliseconds();20   
      UpdateTime=ElapsedMilliseconds()
      ;     ( NPC)   
    EndIf
    
  ;     Escape
  Until Inkey() = Chr(27)
  
  CloseDatabase(0)
  CloseNetworkServer(0)
  
Else
  PrintN("Server start failed on port "+Str(#Port)+".")
  Delay(5000)
EndIf

; IDE Options = PureBasic 4.60 (Windows - x86)
; ExecutableFormat = Console
; Folding = Ag
; EnableXP
; Executable = ..\gserver